/* Zaklady programovani v C++
   Okomentovane priklady ze cviceni ... struktura Zlomek (varianta bez referenci), eukliduv algoritmus, definice operatoru
*/

#include<iostream>
using namespace std;

struct Zlomek
{
	int citatel;
	int jmenovatel;
};


/* Funkce vrati nejvtho spolenho dlitele sel x a y.
*/
int nsd(int x, int y)
{
	if (x == 0)
		return y;
	if (y == 0)
		return x;

	if (x < 0)
		x = -x;
	if (y < 0)
		y = -y;

	while (x != y)
	{
		if (x > y)
			x -= y;
		else // if (y > x)
			y -= x;
	}
	return x;
}

/* Funkce pevede zlomek do zkladnho tvaru.
*/
Zlomek zakladni_tvar(Zlomek z)
{
	int x = nsd(z.citatel, z.jmenovatel);
	z.citatel /= x;
	z.jmenovatel /= x;

	if (z.jmenovatel < 0)
	{
		z.citatel = -z.citatel;
		z.jmenovatel = -z.jmenovatel;
	}
	return z;
}

/* Funkce vynasobi dva zlomky a vrati vysledek.
   Parametry jsou predavane hodnotou. */
Zlomek vynasob(Zlomek x, Zlomek y)
{
	Zlomek z;
	z.citatel = x.citatel * y.citatel;
	z.jmenovatel = x.jmenovatel * y.jmenovatel;
	z = zakladni_tvar(z);
	return z;
}

/* Funkce vydeli dva zlomky a vrati vysledek.
   Parametry jsou predavane odkazem. */
Zlomek vydel(Zlomek x, Zlomek y)
{
	Zlomek z;
	z.citatel = x.citatel * y.jmenovatel;
	z.jmenovatel = x.jmenovatel * y.citatel;
	z = zakladni_tvar(z);
	return z;
}

/* Funkce secte dva zlomky a vrati vysledek.
   Parametry jsou predavane odkazem. */
Zlomek secti(Zlomek x, Zlomek y)
{
	Zlomek z;
	z.citatel = (x.citatel * y.jmenovatel + y.citatel * x.jmenovatel);
	z.jmenovatel = x.jmenovatel * y.jmenovatel;
	z = zakladni_tvar(z);
	return z;
}

/* Funkce odecte dva zlomky a vrati vysledek.
   Parametry jsou predavane odkazem. */
Zlomek odecti(Zlomek x, Zlomek y)
{
	Zlomek z;
	z.citatel = (x.citatel * y.jmenovatel - y.citatel * x.jmenovatel);
	z.jmenovatel = x.jmenovatel * y.jmenovatel;
	z = zakladni_tvar(z);
	return z;
}

/* Peten opertoru * pro parametry typu Zlomek */
Zlomek operator * (Zlomek x, Zlomek y)
{
	return vynasob(x, y);
}

Zlomek operator / (Zlomek x, Zlomek y)
{
	return vydel(x, y);
}

Zlomek operator + (Zlomek x, Zlomek y)
{
	return secti(x, y);
}

Zlomek operator - (Zlomek x, Zlomek y)
{
	return odecti(x, y);
}

/* Vypis Zlomku na konzoli. */
void vypis(Zlomek z)
{
	cout << z.citatel << " / " << z.jmenovatel << endl;
}

int main()
{
	Zlomek x1 = { 1,2 };
	Zlomek x2 = { -2,3 };

	Zlomek x3 = vynasob(x1, x2); 
	vypis(x3);
	
	x3 = (x1 / x2);
	vypis(x3);
	x3 = x1 * x2 + x3 / x2 - x3 * x1;
	vypis(x3);

	// operace s nulou
	x1 = { 0, 6 };
	x2 = { 1, 2 };
	x3 = x1 * x2;
	vypis(x3);
	x3 = x2 / x1;
	vypis(x3);

	return 0;
}


