/* Zaklady programovani v C++
   Okomentovane priklady ze cviceni ... textove retezce a datovy typ string II
*/

#include<iostream>
#include<cstring> // strlen, strcpy, strcmp 
#include<string>  // string

using namespace std;

/* Funkce vrati delku textoveho retezce s. */
int delka_retezce(const char s[])
{
	int n = 0;
	while (s[n] != '\0')
		n++;
	return n;
}

/* Funkce vrati delku textoveho retezce s. */
int delka_retezce(string s)
{
	int n = 0;
	while (s[n] != '\0')
		n++;
	return n;
}

/* Funkce vrati textovy retezec s, ve kterem budou vsechna mala pismena nahrazena velkymi. Zbyle znaky budou ponechany beze zmeny. */
string na_velka(string s)
{
	int delka = delka_retezce(s); // s.len();
	for (int i = 0; i < delka; i++)
	{
		if (s[i] >= 'a' && s[i] <= 'z')
			s[i] -= 'a' - 'A';
	}
	return s;
}

/* Funkce nahradi vsechna mala pismena v retezci s velkymi. Zbyle znaky budou ponechany beze zmeny. */
void na_velka(char s[])
{
	int delka = delka_retezce(s); // s.len();
	for (int i = 0; i < delka; i++)
	{
		if (s[i] >= 'a' && s[i] <= 'z')
			s[i] -= 'a' - 'A';
	}
}

/* Funkce nacte cely radek z konzole, nahradi mala pismena velkymi, vsledn text vypise. */
void cely_radek()
{
	string s;
	cout << "Zadej radek textu:" << endl;
	getline(cin, s);
	cout << na_velka(s) << endl;
}

/* Funkce nacte cely radek z konzole, nahradi mala pismena velkymi, vsledn text vypise. */
void cely_radek1()
{
	char s[256];
	cout << "Zadej radek textu:" << endl;
	cin.getline(s, 255);
	na_velka(s);
	cout << s << endl;
}

/* Funkce zasifruje text zprava pomoci substitucni sifry posunem o "posun" znaku. */
string zasifruj_substituci(string zprava, int posun)
{
	posun = posun % 26;       // ('Z' - 'A' + 1)
	if (posun < 0)
		posun += 26;          // ('Z' - 'A' + 1);

	zprava = na_velka(zprava);

	int n = delka_retezce(zprava);
	for (int i = 0; i < n; i++)
	{
		if ('A' <= zprava[i] && zprava[i] <= 'Z')
		{
			zprava[i] += posun;
			if (zprava[i] > 'Z')
				zprava[i] -= 26;  // ('Z' - 'A' + 1);
		}
	}
	return zprava;
}

int main()
{
	string x = "ABCDEFGHIJKLMNOPQRSTUVXYZ 1234567890 abcdefghijklmnopqrstuvxyz .;(*)";
	cout << x << endl;
	cout << na_velka(x) << endl;

	string z = zasifruj_substituci(x, 138); 
	cout << z << endl;
	z = zasifruj_substituci(z, -138);
	cout << z << endl;
	
	cely_radek();
	cely_radek1();

	return 0;
}
